################################################################################
# Globally shared configuration
################################################################################

default:
  image: ${CI_DEPENDENCY_PROXY_DIRECT_GROUP_IMAGE_PREFIX}/golang:${GO_VERSION}-${DEBIAN_VERSION}
  tags:
    - gitlab-org

#
# Shared configurations
#

.yarn_install:
  before_script:
    - node --version
    # https://github.com/nodejs/corepack?tab=readme-ov-file#manual-installs
    - npm uninstall -g yarn pnpm
    - npm install -g corepack@${COREPACK_VERSION}
    - corepack enable
    - yarn --version
    - yarn install --immutable

.frontend:
  image: ${CI_DEPENDENCY_PROXY_DIRECT_GROUP_IMAGE_PREFIX}/node:${NODE_VERSION}-alpine${ALPINE_VERSION}
  extends:
    - .yarn_install

#
# Retry a job automatically if it fails (2 times)
#
.retry:
  retry: 2

#
# Shared rules
#

.rules_dev:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'

.rules_dev_and_prod:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Default branch pipeline"'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Upstream review app pipeline"'

.rules_dev_and_prod_no_upstream:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Default branch pipeline"'

.rules_prod:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Default branch pipeline"'

.rules_asdf:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
      changes:
        - ".tool-versions"

.rules_docs:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
      changes:
        - "doc/**/*"
        - ".gitlab-ci.yml"

.rules_navigation:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
      changes:
        - "data/navigation.yaml"

.rules_docker_images:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Build docker images pipeline"'
      when: manual
      allow_failure: true

.rules_docker_image_tests:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Build docker images pipeline"'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
      changes:
        - $DOCKERFILE
        - .gitlab-ci.yml

.rules_docker_single_images:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Stable branch pipeline"'

.rules_docker_single_images_tests:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Stable branch pipeline"'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
      changes:
        - $DOCKERFILE

.rules_site_tests:
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Hourly site deployment pipeline"'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Default branch pipeline"'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Stable branch pipeline"'
